/*
 * circuit2.c
 * output ok, now we go for INPUT like the other one...
 * [eichin:19880403.0912EST]
 */


#include <stdio.h>

#include <msimdecl.h>
#include <msimfunc.h>

main(argc, argv)
     int argc;
     char **argv;
{
  int dummy = init_run();
  Wirelist master = getblock();
  Wire A = makewire("A", UNDEFINED);
  Wire B = makewire("B", UNDEFINED);
  Wire C = makewire("C", UNDEFINED);
  Wirelist AA = make_wirelist_1(A);
  Wirelist BB = make_wirelist_1(B);
  Wirelist CC = make_wirelist_1(C);

  Wirelist CAB = make_wirelist_3(C, A, B);
  Wirelist ABC = make_wirelist_3(A, B, C);
  WFile wff;
  Timeline t1;
  Wirelist wl;
  Wire ww;
  
  /* make the Master wirelist */
  add_item(master, WIRELIST, WIRE, wire, A);
  add_item(master, WIRELIST, WIRE, wire, B);
  add_item(master, WIRELIST, WIRE, wire, C);
  add_item(master, WIRELIST, WFILE, wfile, &wff);

  /* open the file, set up wff */
  {
    FILE *f = fopen("TESTINPUT", "r");
    if(!f)
      {
	fprintf(stderr, "%s: Error opening Input file <%s>\n",
		argv[0], "TESTINPUT");
	exit(1);
      }
    wff.filedesc = f;
    wff.next = 1;
  }  
  /* make the dependencies for the AND function */
  add_depends(A, and_func, CAB);
  add_depends(B, and_func, CAB); /* C = A & B */

  /* make the dependencies for the print function */
  add_depends(A, out_func, AA);
  add_depends(B, out_func, BB);
  add_depends(C, out_func, CC); /* On ANY change, print a, b, c */
  
  ww = A;
  find_item(ww, WIRE, FUTURE);
  t1 = ww->data.WIRE.future;
  add_event(t1, LOGIC_HI, 100);
  add_event(t1, LOGIC_LOW, 200);

  ww = B;
  find_item(ww, WIRE, FUTURE);
  t1 = ww->data.WIRE.future;
  add_event(t1, LOGIC_HI, 50);
  add_event(t1, LOGIC_LOW, 150);

  run_all(master);
}

