#define EXPAND(refptr)\
{\
  ASSERT(refptr->tag.CTL == END);\
  if (refptr->data.CTL == end)\
    {\
      ropeptr tmpptr;\
      \
      refptr->tag.CTL = NEXT_FORWARD;\
\
      tmpptr = getblock();\
      ASSERT(refptr->tag.CTL == NEXT_BACKWARD);\
      tmpptr->data.NEXT = refptr-1;\
\
      refptr = refptr->data.NEXT = tmpptr+1;\
    }\
}
#define INC(refptr)\
{\
  if(((++refptr)->tag.CTL == NEXT_FORWARD)\
     || (refptr->tag.CTL == NEXT_FORWARD_UNALIGNED))\
    {\
      refptr = refptr->data.NEXT;\
    }\
}
#define START(refptr) INC(refptr)
#define DEC(refptr)\
{\
  if(((--refptr)->tag.CTL == NEXT_BACKWARD)\
     || (refptr->tag.CTL == NEXT_BACKWARD_UNALIGNED))\
    {\
      refptr = refptr->data.NEXT;\
    }\
}
#define insert_cell(refptr)\
{\
  rope_elem cpy, cpy2;\
  cpy.tag.CTL = END;\
  cpy.data.CTL = end;\
\
  while(refptr->tag.CTL != END)\
    {\
      cpy2 = *refptr;\
      *refptr = cpy;\
      cpy = cpy2;\
      INC(refptr);\
    }\
  EXPAND(refptr);\
  *refptr = cpy;\
}
#define compress(refptr)\
{\
  ASSERT(refptr->tag.CTL == END);\
  refptr--;\
  if (refptr->tag.CTL == NEXT_BACKWARD)\
    {\
      ropeptr savptr;\
      savptr = refptr->data.NEXT;\
      make_free(refptr);\
      refptr = savptr++;	/* savptr is the tail of the BACK block */\
      savptr->tag.CTL = END;\
      savptr->data.CTL = end;\
    }\
  if (refptr->tag.CTL == NEXT_BACKWARD_UNALIGNED)\
    {\
      ropeptr savptr;\
      savptr = refptr->data.NEXT;\
      refptr->tag.CTL = END;\
      refptr->data.CTL = end;\
      refptr = savptr++;	/* savptr is NOT the tail...*/\
      savptr->tag.CTL = END;\
      savptr->data.CTL = notend;\
    }\
}
#define useup(refptr, ENDHANDLER)\
{\
  refptr->tag.CTL = END;\
  refptr->data.CTL = notend;\
  refptr++;\
  if (refptr->tag.CTL == END)\
    {\
      make_free(refptr);\
      ENDHANDLER;		/* usually break or continue... */\
    }\
  if (refptr->tag.CTL == NEXT_FORWARD)\
    {\
      ropeptr nxtptr;\
      nxtptr = refptr->data.NEXT;\
      /*       s2ptr = refptr;??? */\
      refptr->tag.CTL = END;\
      refptr->data.CTL = end;\
      while(refptr->tag.CTL != BEGIN)\
	{\
	  refptr --;\
	}\
      (--nxtptr)->tag.CTL = BEGIN;\
      nxtptr->data.NEXT = refptr->data.NEXT;\
      make_free(refptr);\
\
      refptr = nxtptr+1;\
    }\
}
#define back_trace(refptr)\
{\
  while(refptr->tag.CTL != BEGIN)\
    {\
      refptr --;\
    }\
  make_free(refptr);\
}
#define make_free(refptr)\
{\
  refptr->tag.CTL = FREELIST;\
  refptr->data.NEXT = nextfree;\
  nextfree = refptr;\
}
#define set_item(wire, TYPE, piece, partname, value)\
{\
  EXPAND(wire);\
  wire->tag.TYPE = piece;\
  (wire->data.TYPE.partname) = value;\
}
#define set_event(evptr, value, time)\
{\
  EXPAND(evptr);\
  evptr->tag.EVENT = value;\
  evptr->data.EVENT = time;\
}
#define add_item(wire, TYPE, piece, partname, value)\
{\
  set_item(wire->data.NEXT, TYPE, piece, partname, value);\
  INC(wire->data.NEXT);\
}
#define add_event(timlin, value, time)\
{\
  set_event(timlin->data.NEXT, value, time);\
  INC(timlin->data.NEXT);\
}
#define add_chain(wire, TYPE, piece, partname)\
{\
  add_item(wire, TYPE, piece, partname, getblock());\
}
#define find_item(wire, TYPE, value)\
{\
  while(wire->tag.TYPE != END)\
    {\
      if(wire->tag.TYPE == value) break;\
      INC(wire);\
    }\
}
#define nextwire(argv, wire, time)\
{\
  wire = argv->data.GENERIC.genwire;\
  ASSERT(argv->tag.GENERIC == genwire);\
  find_item(wire, WIRE, FUTURE);\
  time = wire->data.WIRE.future;\
  INC(argv);\
}
#define readnextwire(argv, wire, time)\
{\
  wire = argv->data.GENERIC.genwire;\
  ASSERT(argv->tag.GENERIC == genwire);\
  find_item(wire, WIRE, NOW);\
  time = wire->data.WIRE.now;\
  INC(argv);\
}
